<?php

/** S options */
class SteachsOptions {

	function getOptions() {
		$options = get_option('Steachs_options');
		if (!is_array($options)) {
			$options['google_cs'] = false;
			$options['google_cs_cx'] = '';
			$options['feed'] = false;
			$options['feed_url'] = '';
			$options['steachs_logo'] = false;
			$options['steachs_logourl'] = '';
			$options['indexfeature'] = false;
			update_option('Steachs_options', $options);
		}
		return $options;
	}

	function add() {
		if(isset($_POST['Steachs_save'])) {
			$options = SteachsOptions::getOptions();

			// google custom search engine
			if ($_POST['google_cs']) {
				$options['google_cs'] = (bool)true;
			} else {
				$options['google_cs'] = (bool)false;
			}
			$options['google_cs_cx'] = stripslashes($_POST['google_cs_cx']);

			if ($_POST['feed']) {
				$options['feed'] = (bool)true;
			} else {
				$options['feed'] = (bool)false;
			}
			$options['feed_url'] = stripslashes($_POST['feed_url']);
			
			if ($_POST['steachs_logo']) {
				$options['steachs_logo'] = (bool)true;
			} else {
				$options['steachs_logo'] = (bool)false;
			}
			$options['steachs_logourl'] = stripslashes($_POST['steachs_logourl']);
			if ($_POST['indexfeature']) {
				$options['indexfeature'] = (bool)true;
			} else {
				$options['indexfeature'] = (bool)false;
			}
			update_option('Steachs_options', $options);

		} else {
			SteachsOptions::getOptions();
		}

		add_theme_page(__('Current Theme Options', 'scorpio'), __('Current Theme Options', 'scorpio'), 'edit_themes', basename(__FILE__), array('SteachsOptions', 'display'));
	}

	function display() {
		$options = SteachsOptions::getOptions();
?>

<form action="#" method="post" enctype="multipart/form-data" name="S_form" id="S_form">
	<div class="wrap">
		<h2><?php _e('Current Theme Options', 'scorpio'); ?></h2>
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row"><?php _e('Logo Title Options', 'scorpio'); ?></th>
					<td>
						<label>
							<input name="steachs_logo" type="checkbox" value="checkbox" <?php if($options['steachs_logo']) echo "checked='checked'"; ?> />
							 <?php _e('Use Image Logo', 'scorpio'); ?>
						</label>
						<br/>
						<?php _e('Logo url:', 'scorpio'); ?>
						 <input type="text" name="steachs_logourl" id="steachs_logourl" class="code" size="40" value="<?php echo($options['steachs_logourl']); ?>">
						<br/>
						<?php _e('image url with \"http://\"','scorpio'); ?>
					</td>
				</tr>
			</tbody>
		</table>
		
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row"><?php _e('Search', 'scorpio'); ?></th>
					<td>
						<label>
							<input name="google_cs" type="checkbox" value="checkbox" <?php if($options['google_cs']) echo "checked='checked'"; ?> />
							 <?php _e('Using google custom search engine.', 'scorpio'); ?>
						</label>
						<br/>
						<?php _e('CX:', 'scorpio'); ?>
						 <input type="text" name="google_cs_cx" id="google_cs_cx" class="code" size="40" value="<?php echo($options['google_cs_cx']); ?>">
						<br/>
						<?php printf(__('Find <code>name="cx"</code> in the <strong>Search box code</strong> of <a href="%1$s">Google Custom Search Engine</a>, and type the <code>value</code> here.<br/>Example: <code>0711196565645086:vgsvq-2eeoz</code>', 'scorpio'), 'http://www.google.com/coop/cse/'); ?>
					</td>
				</tr>
			</tbody>
		</table>

		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row"><?php _e('Feed', 'scorpio'); ?></th>
					<td>
						<label>
							<input name="feed" type="checkbox" value="checkbox" <?php if($options['feed']) echo "checked='checked'"; ?> />
							 <?php _e('Use Custom feed.', 'scorpio'); ?>
						</label><br />
						 <?php _e('URL:', 'scorpio'); ?> <input type="text" name="feed_url" id="feed_url" class="code" size="60" value="<?php echo($options['feed_url']); ?>">
					</td>
				</tr>
			</tbody>
		</table>		
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row"><?php _e('Index Feature Post', 'scorpio'); ?></th>
					<td>
						<label>
							<input name="indexfeature" type="checkbox" value="checkbox" <?php if($options['indexfeature']) echo "checked='checked'"; ?> />
							 <?php _e('Use index feature', 'scorpio'); ?>
						</label>
					</td>
				</tr>
			</tbody>
		</table>
		<p class="submit">
			<input class="button-primary" type="submit" name="Steachs_save" value="<?php _e('Save Changes', 'scorpio'); ?>" />
		</p>
	</div>
</form>


<?php
	}
}
add_action('admin_menu', array('SteachsOptions', 'add'));
add_action ('init', 'theme_init');
require_once('carusel.php');
define('FEATURED_SPEED', 5); // seconds
define('FEATURED_POSTS', 10); // copunt
function theme_init(){
	load_theme_textdomain('scorpio', get_template_directory() . '/languages');
}
    add_action ('init', 'theme_init');
if ( function_exists('register_sidebar') )
        register_sidebar(array(
        'before_widget' => '<div class="sidebar">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>',
    )); 
if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Footer-Left',
        'before_widget' => '',
        'after_widget' => '',
        'before_title' => '<h3>',
        'after_title' => '</h3>',
    ));
if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Footer-Center',
        'before_widget' => '',
        'after_widget' => '',
        'before_title' => '<h3>',
        'after_title' => '</h3>',
    ));
if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Footer-Right',
        'before_widget' => '',
        'after_widget' => '',
        'before_title' => '<h3>',
        'after_title' => '</h3>',
    ));
?>
<?php
	function s_pagenavi($range = 6){
  global $paged, $wp_query;
  if ( !$max_page ) {
    $max_page = $wp_query->max_num_pages;
  }
  if($max_page > 1){
    if(!$paged){
      $paged = 1;
    }
echo '<div id="paviinfo">文章頁次'.$paged.'/'.$max_page.'</div>';
    if($paged != 1){
      echo "<a href='" . get_pagenum_link(1) . "' class='extend' title='首頁'>首頁</a>";
    }
    previous_posts_link(' « ');
    if($max_page > $range){
      if($paged < $range){
        for($i = 1; $i <= ($range + 1); $i++){
          echo "<a title=".'"第'.$i.'頁"'. "href='" . get_pagenum_link($i) ."'";
          if($i==$paged) echo " class='current'";
          echo ">$i</a>";
        }
      }
      elseif($paged >= ($max_page - ceil(($range/2)))){
        for($i = $max_page - $range; $i <= $max_page; $i++){
          echo "<a title=".'"第'.$i.'頁"'. "href='" . get_pagenum_link($i) ."'";
          if($i==$paged) echo " class='current'";
          echo ">$i</a>";
        }
      }
      elseif($paged >= $range && $paged < ($max_page - ceil(($range/2)))){
        for($i = ($paged - ceil($range/2)); $i <= ($paged + ceil(($range/2))); $i++){
          echo "<a title=".'"第'.$i.'頁"'. "href='" . get_pagenum_link($i) ."'";
          if($i==$paged) echo " class='current'";
          echo ">$i</a>";
        }
      }
    }
    else{
      for($i = 1; $i <= $max_page; $i++){
        echo "<a title=".'"第'.$i.'頁"'. "href='" . get_pagenum_link($i) ."'";
        if($i==$paged) echo " class='current'";
        echo ">$i</a>";
      }
    }
    next_posts_link(' » ');
    if($paged != $max_page){
      echo "<a href='" . get_pagenum_link($max_page) . "' class='extend' title='最後一頁'>最後一頁</a>";
    }
  }
}
	?>
<?php
function srelated_posts($before_title="",$after_title="") {	
	global $wpdb, $post,$table_prefix;
	if(!$post->ID){return;}
	$now = current_time('mysql', 1);
	$tags = wp_get_post_tags($post->ID);
	
	$taglist = "'" . $tags[0]->term_id. "'";
	
	$tagcount = count($tags);
	if ($tagcount > 1) {
		for ($i = 1; $i < $tagcount; $i++) {
			$taglist = $taglist . ", '" . $tags[$i]->term_id . "'";
		}
	}	
	$limitclause = "LIMIT 5";	
	$q = "SELECT p.ID, p.post_title, p.post_content,p.post_excerpt, p.post_date,  p.comment_count, count(t_r.object_id) as cnt FROM $wpdb->term_taxonomy t_t, $wpdb->term_relationships t_r, $wpdb->posts p WHERE t_t.taxonomy ='post_tag' AND t_t.term_taxonomy_id = t_r.term_taxonomy_id AND t_r.object_id  = p.ID AND (t_t.term_id IN ($taglist)) AND p.ID != $post->ID AND p.post_status = 'publish' AND p.post_date_gmt < '$now' GROUP BY t_r.object_id ORDER BY cnt DESC, p.post_date_gmt DESC $limitclause;";	
	$related_posts = $wpdb->get_results($q);
	foreach ($related_posts as $related_post ){
		$output .=  '<li><a href="'.get_permalink($related_post->ID).'" title="'.wptexturize($related_post->post_title).'">'.wptexturize($related_post->post_title).'</a></li>';			
	}	
	$output = '<ul class="related_post">' . $output . '</ul>';		
	return $output;
}
function s_related_posts(){
	$output = srelated_posts() ;
	echo $output;
}
function s_random_lists($num_limit = 5 , $exclude = "" , $date_limit = "" , $echo = true , $list = true){
		$out = "";
		if ( $num_limit < 1 ) $num_limit = "-1";
		if ( !$date_limit_ts = strtotime($date_limit) ) $date_limit = false;
		if ( !$date_limit ){
        	$posts = get_posts('offset=0&numberposts='.$num_limit.'&exclude='.$exclude.'&orderby=rand');
		} else {
        	$posts = get_posts('offset=0&numberposts=-1&exclude='.$exclude.'&orderby=rand');
		}
		$postscount = count($posts);
		if ( $num_limit < 1 ) $num_limit = $postscount;
		if ( $postscount < $num_limit ) $num_limit = $postscount ;
		for ( $i = 0 ; $i < $num_limit ; $i++ ){
			if ( !$date_limit or $date_limit_ts < strtotime( $posts[$i]->post_date )){
				if ( $list ) $out.= '<li class="random-post-link">'."\n";
  				$out.= '<a href="'.get_permalink($posts[$i]->ID).'" title="'.$posts[$i]->post_title.'">'.$posts[$i]->post_title.'</a>'."\n";
				if ( $list ) $out.= '</li>'."\n";
			}else{
				if ( $postscount > $num_limit ) $num_limit++;
			}
		}
		if ( $list ) $out = '<ul class="random-post-link">'."\n".$out.'</ul>'."\n";
		if ( $echo ){
  			echo $out;
		} else {
			return $out;
		}
	}
?>